white space cleanup
[xfstests-dev.git] / tools / srcdiff
1 #!/usr/bin/perl -w
2 use strict;
3
4 # srcdiff is used to compare current user level code with the current
5 # kernel code and advise of any differences between files which are
6 # sharing some or all of their content.
7
8 # There are two classes of sharing which we will check - header files
9 # in the include directory, which must be exactly the same (use diff)
10 # and source files which contain routines which must be exactly the
11 # same (but the userland file is always a subset of the kernel file,
12 # and hence a more flexible mechanism to "diff" is required).
13
14 # NB: to cross check that srcdiff is finding all the functions in the
15 #     user source file, providing you have "mkproto" installed, you
16 #     can "cd cmd/xfsprogs/libxfs" and cut&paste this in a bourne shell:
17 #     $ for file in xfs_*.c; do
18 #     > mkproto -nps < $file | perl -ne '
19 #     > END { print "    $count\t- " }
20 #     > s/^.* (xfs\w+|\*xfs\w+|xlog\w+|\*xlog\w+) \(.*/\1/ && { $count++ }'
21 #     > echo $file
22 #     > done
23 # (compare this to "srcdiff | fgrep Total:")
24
25
26 die "WORKAREA not set" unless defined $ENV{'WORKAREA'};
27 chdir $ENV{'WORKAREA'};
28 my $xdiff = $ENV{'XDIFF'};
29 my $quiet=0;
30 my $usage=0;
31
32 foreach (@ARGV) {
33         if (/^-q$/) {
34                 $quiet++;
35         } else {
36                 print STDERR "Illegal option $_\n";
37                 $usage++;
38         }
39 }
40
41 if ($usage) {
42     print STDERR "Usage: $0 [-q]\n";
43     exit 1;
44 }
45
46 my @pkglist = qw( attr acl dmapi xfsdump xfsprogs );
47 my @difflist = qw(
48         xfs_ag.h  xfs_alloc.h  xfs_alloc_btree.h xfs_arch.h
49         xfs_attr_leaf.h  xfs_attr_sf.h  xfs_bit.h  xfs_bmap.h
50         xfs_bmap_btree.h  xfs_btree.h  xfs_buf_item.h
51         xfs_da_btree.h  xfs_dfrag.h  xfs_dinode.h  xfs_dir.h
52         xfs_dir2.h  xfs_dir2_block.h  xfs_dir2_data.h
53         xfs_dir2_leaf.h  xfs_dir2_node.h  xfs_dir2_sf.h
54         xfs_dir_leaf.h  xfs_dir_sf.h  xfs_dqblk.h  xfs_dquot_item.h
55         xfs_extfree_item.h  xfs_ialloc.h  xfs_imap.h
56         xfs_ialloc_btree.h  xfs_inode.h  xfs_inode_item.h
57         xfs_inum.h  xfs_log.h  xfs_log_priv.h  xfs_log_recover.h
58         xfs_mount.h  xfs_quota.h  xfs_rtalloc.h
59         xfs_sb.h  xfs_trans.h  xfs_trans_space.h  xfs_types.h
60         xfs_fs.h xfs_acl.h xfs_cap.h xfs_mac.h
61 );
62
63 sub straightdiff {
64         my ( $file, $prefix1, $prefix2 ) = @_;
65
66         `diff $prefix1/$file $prefix2/$file >/dev/null 2>&1`;
67         if (!$quiet) {
68                 print sprintf("\t%-35s ... ", $file);
69                 if ($? != 0)    { print "FAILED\n"; }
70                 else            { print "ok\n"; }
71         } elsif ($? != 0) { 
72                 printf("\t%-35s ... ", $file);
73                 print "FAILED\n"; 
74         }
75 }
76
77 my $first = shift @pkglist;
78 foreach (@pkglist) {
79         print "\n=== Checking $_ package ===\n";
80         straightdiff 'buildrules', "cmd/$first/include", "cmd/$_/include";
81         straightdiff 'buildmacros', "cmd/$first/include", "cmd/$_/include";
82 }
83 print "\n=== Checking headers ===\n";
84 foreach (@difflist) {
85         straightdiff $_, 'cmd/xfsprogs/include', 'linux/fs/xfs';
86 }
87 straightdiff 'dmapi_kern.h', 'cmd/dmapi/include', 'linux/include/linux';
88 straightdiff 'dmapi.h', 'cmd/dmapi/include', 'linux/include/linux';
89 straightdiff 'arch.h', 'cmd/xfsprogs/include', 'linux/fs/xfs/support';
90
91
92 # setstate
93 # Implements a tri-state FSA, see comments for state transitions
94 #  (knows about the way the XFS kernel code is written, & makes
95 #   some assumptions so as to not need to parse generic C code).
96 # Accepts one line at a time from a source file, picking out the
97 #   function bodies so they can be subsequently compared.
98
99
100 my $line;       # line number in current source file
101 my $state;      # current FSA state
102 my $funcbody;   # current function body (contents)
103
104 sub setstate {
105         my ( $newline ) = @_;
106         $line++;
107
108         # - state 0:
109         #       if line looks like start of a function, transition to 1
110         #               & squirrel line away as line 1 of current function
111         if ($state == 0) {
112                 if ($newline =~ m/^[xfs|xlog]/) {
113                         $state = 1;
114                         $funcbody = $newline;
115                 }
116         }
117
118         # - state 1:
119         #       if line looks like start of a function, stay here
120         #               & squirrel line away as line 1 of current function
121         #       otherwise if line isn't start of function body,
122         #               squirrel line away as next line of current function
123         #               (args/..., but not sure this is a real function yet)
124         #       otherwise (start of function)
125         #               squirrel line away as next line of current function
126         #               transition to state 2
127         elsif ($state == 1) {
128                 if ($newline =~ m/^[xfs|xlog]/) {
129                         $funcbody = $newline;
130                 }
131                 elsif ($newline =~ m/^\{/) {
132                         $state = 2;
133                         $funcbody .= $newline;
134                 }
135         }
136
137         # - state 2:
138         #       if line looks like end of function body,
139         #               squirrel line away as last line of current function
140         #               tell someone we have a complete function ready
141         #               transition to state 0
142         #       otherwise
143         #               squirrel line away as next line of current function
144         elsif ($state == 2) {
145                 $funcbody .= $newline;
146                 if ($newline =~ m/^\}/) {
147                         $state = 0;
148                         return $funcbody;
149                 }
150         }
151
152         else {
153                 die "unknown state transition";
154         }
155         return undef;   # i.e. not at end of a function
156 }
157
158 sub listfuncs {
159         my ( $file ) = @_;
160         my @funcs;
161
162         $funcbody = '';
163         $state = $line = 0;
164
165         open(USER, "$file") || die "cannot open $file";
166         while (<USER>) {
167                 my $func = setstate($_);
168                 push @funcs, $func if (defined($func)); # store function away
169         }
170         close USER;
171         return @funcs;
172 }
173
174 sub hashfuncs {
175         my ( $file ) = @_;
176         my %funcs;
177
178         $funcbody = '';
179         $state = $line = 0;
180
181         open(KERN, "$file") || die "cannot open $file";
182         while (<KERN>) {
183                 my $func = setstate($_);
184                 if (defined($func)) {
185                         $func =~ m/^([xfs|xlog]\w+)\s*\(/;
186                         next unless defined($1);
187                         my $name = $1;
188                         if (defined($func)) {
189                                 $funcs{$name} = $func;  # store function away
190                         }
191                 }
192         }
193         close KERN;
194         return %funcs;
195 }
196
197 sub diffme {
198         my ( $sa, $sb ) = @_;
199
200         return unless defined($xdiff);
201
202         open(FILEA, "> /tmp/diff.user.$$") || die "cannot write to /tmp/diff.user.$$";
203         open(FILEB, "> /tmp/diff.kern.$$") || die "cannot write to /tmp/diff.kern.$$";
204         print FILEA $sa;
205         print FILEB $sb;
206         close FILEA;
207         close FILEB;
208         `$xdiff /tmp/diff.user.$$ /tmp/diff.kern.$$`;
209         unlink ("/tmp/diff.user.$$","/tmp/diff.kern.$$");
210 }
211
212 sub functiondiff {
213         my ( $file, $prefix1, $prefix2 ) = @_;
214         my $plural = '';
215         my $count = 0;
216         my $name;
217         my $found = 0;
218
219         print "\n=== Checking $file routines ===\n" unless ($quiet);
220
221         # iterate over user funcs, match up to kernel funcs
222         # 
223         my @user = listfuncs "$prefix1/$file";
224         my %kern = hashfuncs "$prefix2/$file";
225
226         foreach my $userfunc (@user) {
227                 
228                 $userfunc =~ m/^([xfs|xlog]\w+)\s*\(/;
229                 next unless (defined($1));
230                 $name = $1;
231                 $count++;
232
233                 if (exists($kern{$name})) {
234                         if ($userfunc ne $kern{$name}) {
235                                 print "\n=== $file routines ===\n"
236                                     if (!$found++ && $quiet);
237                                     
238                                 printf("\t%-35s ... ", $name);
239                                 print "FAILED\n";
240                                 diffme $userfunc, $kern{$name};
241                         }
242                         elsif (!$quiet) {
243                                 printf("\t%-35s ... ", $name);
244                                 print "ok\n";
245                         }
246                 }
247                 else {
248                         print "Cannot find kernel function $userfunc";
249                         print " in file $prefix2/$file\n";
250                 }
251         }
252         ($count != 1) && ( $plural = 's' );
253         print "( Total: $count routine$plural checked in $file )\n" unless ($quiet);
254 }
255
256 # cmd/xfsprogs/{libxfs,libxlog}/* fs/xfs/*
257 my @funclist = qw(
258         xfs_alloc.c  xfs_alloc_btree.c  xfs_attr_leaf.c
259         xfs_bmap.c  xfs_bmap_btree.c  xfs_btree.c  xfs_da_btree.c
260         xfs_dir.c  xfs_dir2.c  xfs_dir2_block.c  xfs_dir2_data.c
261         xfs_dir2_leaf.c  xfs_dir2_node.c  xfs_dir2_sf.c
262         xfs_dir_leaf.c  xfs_ialloc.c  xfs_ialloc_btree.c
263         xfs_inode.c  xfs_rtalloc.c  xfs_mount.c  xfs_trans.c
264 );
265
266 print "\n=== Checking libxfs code ===\n";
267 foreach (@funclist) {
268         functiondiff $_, 'cmd/xfsprogs/libxfs', 'linux/fs/xfs';
269 }
270 print "\n=== Checking libxlog code ===\n";
271 functiondiff 'xfs_log_recover.c', 'cmd/xfsprogs/libxlog', 'linux/fs/xfs';